;*******************************************************
;             ǻ  (ȭ Ҹ)              *
;  ļ: f=320Hz T=1/320=3121us, 3121usx8=25msec   *
;  ļ: f=480Hz T=1/480=2087us, 2087usx12=25msec  *
;*******************************************************
;
	ORG	0000H		; α׷ 
;
START:	MOV	R3,#20
SOUND:	MOV	R0,#8
LOOP_L:				; f=320Hz T=1/320=3121usec, 3121usx8=25msec
	SETB	P1.0		; Ŀ on
	CALL	L_TONE		; 
	CLR	P1.0		; Ŀ off
	CALL	L_TONE		; 
	DJNZ	R0,LOOP_L
;
	MOV	R0,#12
LOOP_H:				; f=480Hz T=1/480=2087usec, 2087usx12=25msec
	SETB	P1.0		; Ŀ on
	CALL	H_TONE		; 
	CLR	P1.0		; Ŀ off
	CALL	H_TONE		; 
	DJNZ	R0,LOOP_H
	DJNZ	R3,SOUND
;
; No Sound
	CALL	NO_SOUND	; 2ʰ 
	JMP	START
;
L_TONE:				; Duration Time=3121/2=1560.5usec
	MOV	R1,#3
L1:	MOV	R2,#172
L2:	NOP
	DJNZ	R2,L2
	DJNZ	R1,L1
	RET
;
H_TONE:				; Duration Time=2087/2=1043.5usec
	MOV	R1,#3
H1:	MOV	R2,#115
H2:	NOP
	DJNZ	R2,H2
	DJNZ	R1,H1
	RET
;
NO_SOUND:			; 2 ð
	MOV	R0,#20
NS1:	MOV	R1,#133
NS2:	MOV	R2,#250
NS3:	NOP
	DJNZ	R2,NS3
	DJNZ	R1,NS2
	DJNZ	R0,NS1
	RET
	END			; α׷ 




