;****************************************************
;              SHT71 ̿ ½              *
;****************************************************
;
DATA_L	EQU	08H		; SHT71κ  Ʈ
DATA_H	EQU	09H		; SHT71κ  Ʈ
SIGN	EQU	0AH		; ȣ(µ)
ONDO	EQU	0BH		; µ 
SUPDO	EQU	0CH		;  
IMSI	EQU	0DH		; ӽ 
;
RS_LCD	BIT	P2.0		; LCD RS
RW_LCD	BIT	P2.1		; LCD R/W
CE_LCD	BIT	P2.2		; LCD Chip Enable
;
SDATA	BIT	P2.4		; SHT71 DATA
SCK	BIT	P2.5		; SHT71 SCK
;
	ORG	0000H		; α׷ 
	JMP	START
;
START:
        MOV	SP,#50H		;  
;
;	LCD ʱȭ 
;
	MOV	A,#38H	        ; Function Set(8bit, 5X7 dot, 2 line)
	CALL	CMD_WRITE	; 1° 
	CALL	DELAY
	CALL	CMD_WRITE	; 2° 
	CALL	DELAY
	CALL	CMD_WRITE	; 3° 
	CALL	DELAY
	MOV	A,#06H		; Ʈ Ʈ
	CALL	CMD_WRITE	; (巹 , Ʈ )
	MOV	A,#0CH		; ǥ 
	CALL	CMD_WRITE	; (ǥ on, Ŀ on,  off)
	MOV	A,#01H		; ȭ , Ŀ Ȩ ġ
	CALL	CMD_WRITE
	CALL	CONN_RESET	; SHT71   
;
;	µ  ǥ
;
MAIN:
	CALL	TRANS_START	; ۽ 
	MOV	A,#00000011B	; µ 
	CALL	WRITE_BYTE
	CALL	READ_BYTE	; DATA_H(Ʈ), DATA_L(Ʈ)
;
	MOV	A,#3FH		; 14Ʈ ͸ 
	ANL	A,DATA_H
	MOV	DATA_H,A
;
; µ = (SOT-4000)/100
	MOV	R0,DATA_L	; SOT
	MOV	R1,DATA_H
	MOV	R2,#0A0H	; 4000(10)=0FA0H
	MOV	R3,#0FH
	CALL	SUB16		; SOT - 4000
	JC	BELOW
;
	MOV	SIGN,#00H
	MOV	A,DATA_L	; 0 ˻
	CJNE	A,#0A0H,ABOVE
	MOV	A,DATA_H
	CJNE	A,#0FH,ABOVE
	MOV	ONDO,#00H	; 
	JMP	TEMP_DISPLAY
ABOVE:				; µ
	MOV	R3,#00H		; 100(10)=0064H
	MOV	R2,#64H
	CALL	UDIV16		; (SOT-4000)/100
	MOV	ONDO,R0
	JMP	TEMP_DISPLAY	; µǥϴ ѷ 
BELOW:
	MOV	SIGN,#01H	; Ͽµ
	MOV	R0,#0A0H	; 4000(10)=0FA0H
	MOV	R1,#0FH
	MOV	R2,DATA_L	; SOT
	MOV	R3,DATA_H
	CALL	SUB16		; 4000 - SOT
	MOV	R3,#00H		; 100(10)=0064H
	MOV	R2,#64H
	CALL	UDIV16		; (4000-SOT)/100
	MOV	ONDO,R0
;
TEMP_DISPLAY:			; (+), (-) ǥ
        MOV	A,#80H		; Ŀ 1 1 ű
	CALL	CMD_WRITE
	MOV	DPTR,#MSG1	; 'Temperat: ' LCD ǥ
	CALL	DISP_MSG
        MOV     A,SIGN
        CJNE    A,#00H,MINUS	; (+) ˻
	MOV	DPTR,#MSG2	; '+' LCD ǥ
	CALL	DISP_MSG
        JMP     TEMP_VALUE
MINUS:	MOV	DPTR,#MSG3	; '-' LCD ǥ
	CALL	DISP_MSG
;
TEMP_VALUE:			; µ LCD ǥ
        MOV     A,ONDO
        CALL	DISP_DATA	; µ ǥ
	MOV	DPTR,#MSG4	; '' LCD ǥ
	CALL	DISP_MSG
;
;	  ǥ
;
	CALL	TRANS_START	; ۽ 
	MOV	A,#00000101B	;  
	CALL	WRITE_BYTE
	CALL	READ_BYTE	; DATA_H(Ʈ), DATA_L(Ʈ)
	MOV	A,#0FH		; 12Ʈ ͸ 
	ANL	A,DATA_H
	MOV	DATA_H,A
;
	MOV	IMSI,#00H	; SO_RH  ã
        MOV     DPTR,#SO_RH_TBL
RH_LOOP:
	MOV	R0,DATA_L
	MOV	R1,DATA_H
	CLR	A
        MOVC    A,@A+DPTR	; ȯǥ Ʈ 
	MOV	R3,A
	INC	DPTR
        MOVC    A,@A+DPTR	; ȯǥ Ʈ 
	MOV	R2,A
	CALL	SUB16		; SO_RH - ȯǥ 
	JC	FIND
	INC	DPTR
	INC	IMSI
	JMP	RH_LOOP
;
FIND:
	MOV	A,IMSI		; (0.01+0.00008*SO_RH)*250  ã
	MOV	DPTR,#COEFF	; ȯǥ ʱּ
	MOVC	A,@A+DPTR
	MOV	R5,A		;  ãƼ R5 
;
; RH_linear = (-4+0.0405*SO_RH-2.8*10^(-6)*SO_RH^2)*250  ã
        MOV     DPTR,#RH_LIN	; ȯǥ ʱּ
	MOV	A,IMSI
	DEC	A
	MOV	B,#2
	MUL	AB
        MOVC    A,@A+DPTR	; RH_linear Ʈ о
	MOV	R7,A		; R7 
	MOV	A,IMSI
	DEC	A
	MOV	B,#2
	MUL	AB
	INC	DPTR
        MOVC    A,@A+DPTR	; RH_linear Ʈ о
	MOV	R6,A		; R6 
;
	MOV	A,ONDO		; µ A 
	CJNE	A,#25,CHK25
	MOV	R0,#00H		; µ = 25
	MOV	R1,#00H
	JMP	JUST25
;
CHK25:
	JNC	U25
	MOV	A,#25		; µ < 25
	CLR	C
	SUBB	A,ONDO		; 25 - µ
	MOV	R0,A		;  R0 
	MOV	A,R5		; (25-T)*(0.01+0.00008*SO_RH)*250
	MOV	R1,A
	CALL	UMUL8		; R1(Ʈ), R0(Ʈ)
	MOV	A,R1		; R3 <-- R1
	MOV	R3,A
	MOV	A,R0		; R2 <-- R0
	MOV	R2,A
;
	MOV	A,R7		; (25-T)*(0.01+0.00008*SO_RH)*250 + RH_linear*250
	MOV	R1,A
	MOV	A,R6		; R0 <-- R6
	MOV	R0,A
	CALL	SUB16		; R1(Ʈ), R0(Ʈ)
	MOV	R3,#00H
	MOV	R2,#250
	CALL	UDIV16		; RH_true / 250
	MOV	A,R0
	MOV	SUPDO,A		; 
	JMP	HUM_DISPLAY	;  ǥϴ  
;
U25:				; µ > 25
	MOV	A,ONDO		; µ A 
	CLR	C
	SUBB	A,#25		; (µ - 25) 
	MOV	R0,A		;  R0 
	MOV	A,R5		; (T-25)*(0.01+0.00008*SO_RH)*250
	MOV	R1,A
	CALL	UMUL8		; R1(Ʈ), R0(Ʈ)
;
JUST25:				; µ >= 25
	MOV	A,R7		; (T-25)*(0.01+0.00008*SO_RH)*250 + RH_linear*250
	MOV	R3,A
	MOV	A,R6
	MOV	R2,A
	CALL	ADD16		; R1(Ʈ), R0(Ʈ)
	MOV	R3,#00H
	MOV	R2,#250
	CALL	UDIV16		; RH_true / 250
	MOV	A,R0
	MOV	SUPDO,A		; 
;
HUM_DISPLAY:			;  LCD ǥ
        MOV	A,#0C0H		; Ŀ 2 1 ű
	CALL	CMD_WRITE
	MOV	DPTR,#MSG5	; 'Humidity: ' LCD ǥ
	CALL	DISP_MSG
        MOV     A,SUPDO
        CALL	DISP_DATA	;  ǥ
	MOV	DPTR,#MSG6	; '%' LCD ǥ
	CALL	DISP_MSG
	CALL	LONG_DELAY	; ð 
	JMP	MAIN
;
;	Connection Reset
;
CONN_RESET:
	SETB	SDATA		; ʱ
	CLR	SCK
	MOV	R0,#09H
RESET_LOOP:
	SETB	SCK
	NOP
	CLR	SCK
	DJNZ	R0,RESET_LOOP
	RET
;
;	۽(Transmission Start) ƾ
;
TRANS_START:
	SETB	SDATA	; DATA=H
	CLR	SCK	; SCK=L
	NOP
	SETB	SCK	; SCK=H
	NOP
	CLR	SDATA	; DATA=L
	NOP
	CLR	SCK	; SCK=L
	NOP
	SETB	SCK	; SCK=H
	NOP
	SETB	SDATA	; DATA=H
	NOP
	CLR	SCK	; SCK=L
	RET
;
;	SHT71  
;
WRITE_BYTE:
	CLR	C
        MOV     R0,#08H		; Ʈ  = 8
W_LOOP:
	RLC	A
	MOV	SDATA,C
	SETB	SCK		; SCK=H
	CLR	SCK		; SCK=L
        DJNZ    R0,W_LOOP	; 8Ʈ   ݺ
;
	JB	SDATA,$
	SETB	SCK		; SCK=H
	CLR	SCK		; SCK=L
	JB	SDATA,$		; Ϸ  
	RET
;
;	SHT71κ  б
;
READ_BYTE:
	MOV     R0,#08H		; Ʈ  = 8
H_BYTE:
	MOV	C,SDATA		; 1Ʈ 
	SETB	SCK		; SCK=H
	CLR	SCK		; SCK=L
	RLC	A
        DJNZ    R0,H_BYTE	; 8Ʈ   ݺ
	MOV	DATA_H,A	; Ʈ
	CLR	SDATA		; Ʈ  ACK
	SETB	SCK		; SCK=H
	CLR	SCK		; SCK=L
	SETB	SDATA		; Ʈ  ACK
;
	MOV     R0,#08H
L_BYTE:
	MOV	C,SDATA		; 1Ʈ 
	SETB	SCK		; SCK=H
	CLR	SCK		; SCK=L
	RLC	A
        DJNZ    R0,L_BYTE	; 8Ʈ   ݺ
	MOV	DATA_L,A	; Ʈ
	SETB	SDATA		;  
	SETB	SCK		; SCK=H
	CLR	SCK		; SCK=L
	RET
;
;	8Ʈ : P(R1 R0) = X(R0) x Y(R1).
;
UMUL8:	MOV	A,R0
	MOV	B,R1
	MUL	AB
	MOV	R1,B
	MOV	R0,A
	RET
;
;	16Ʈ : S(R1 R0) = X(R1 R0) + Y(R3 R2)
;       C=1̸  ǥ 
;
ADD16:	MOV	A,R0
	ADD	A,R2
	MOV	R0,A
	MOV	A,R1
	ADDC	A,R3
	MOV	R1,A
	RET
;
;	16Ʈ : D(R1 R0) = X(R1 R0) - Y(R3 R2)
;       C=1̸  ǥ 
;
SUB16:	MOV	A,R0
	CLR	C
	SUBB	A,R2	; R0-R2
	MOV	R0,A
	MOV	A,R1
	SUBB	A,R3	; R1-R3
	MOV	R1,A
	RET
;
;	16Ʈ : X(R1 R0) / Y(R3 R2)
; 	(R1 R0), (R3 R2)
;
UDIV16:	MOV	R7,#0
	MOV	R6,#0
	MOV	B,#16		; ݺ

DIV_LOOP:
	CLR	C
	MOV	A,R0
	RLC	A
	MOV	R0,A
	MOV	A,R1
	RLC	A
	MOV	R1,A
	MOV	A,R6
	RLC	A
	MOV	R6,A
	MOV	A,R7
	RLC	A
	MOV	R7,A
	MOV	A,R6
	CLR	C
	SUBB	A,R2
	MOV	DPL,A
	MOV	A,R7
	SUBB	A,R3
	MOV	DPH,A
	CPL	C
	JNC	DIV_1
 	MOV	R7,DPH
	MOV	R6,DPL
DIV_1:	MOV	A,R4
	RLC	A
	MOV	R4,A
	MOV	A,R5
	RLC	A
	MOV	R5,A
	DJNZ	B,DIV_LOOP
	MOV	A,R5		;  R1, R0 
	MOV	R1,A
	MOV	A,R4
	MOV	R0,A
	MOV	A,R7
	MOV	R3,A		;  R3, R2 
	MOV	A,R6
	MOV	R2,A
	RET
;
;	LCD ɾ  ƾ
;
CMD_WRITE:
	MOV	P1,A      	; CPU --> LCD
	CLR	RS_LCD        	; RS=L (ɾ)
	CLR	RW_LCD        	; R/W=L ()
	NOP
	SETB	CE_LCD        	; LCD ο̺
	NOP
	NOP             	;
	CLR	CE_LCD        	; LCD 𽺿̺
	CALL	LCD_BUSY  	; LCD Ϸ  
	RET
;
;	LCD ͸  ƾ
;
DATA_WRITE:
	MOV	P1,A      	; CPU --> LCD
	SETB	RS_LCD        	; RS=H ()
	CLR	RW_LCD        	; R/W=L ()
	NOP
	SETB	CE_LCD        	; LCD ο̺
	NOP
	NOP
	CLR	CE_LCD        	; LCD 𽺿̺
	CALL	LCD_BUSY  	; LCD Ϸ  
	RET
;
;	LCD Busy Flag ˻ ƾ
;
LCD_BUSY:
	CLR	CE_LCD		; LCD 𽺿̺
	SETB	P1.7		; Busy Flag=H
	SETB	RW_LCD		; R/W=H (б)
	CLR	RS_LCD		; RS=L (ɾ)
LB1:	CLR	CE_LCD		; LCD 𽺿̺
	SETB	CE_LCD		; CD ο̺
	JB	P1.7,LB1	; Busy Flag ˻
	CLR	CE_LCD		; Busy Flag 0̸ LCD 𽺿̺
	RET
;
;	޽ LCD ǥϴ ƾ
;
DISP_MSG:
	CLR	A		; A=0
	MOVC	A,@A+DPTR	; ͸ 
	INC	DPTR		; DPTR 
	JZ	END_MSG		;   ˻
	CALL	DATA_WRITE	; LCD ͸ 
	JMP	DISP_MSG	;  
END_MSG:
	RET
;
;	͸ LCD ǥϴ ƾ
;
DISP_DATA:
; µ() R1 
        MOV	B,#10
        DIV	AB
	ADD	A,#30H		; ASCII ڵ ȯ
        CALL    DATA_WRITE
        MOV	A,B		; 1 µ() ǥ
	ADD	A,#30H		; ASCII ڵ ȯ
        CALL    DATA_WRITE
	RET
;
;	ƾ
;
DELAY:	
	MOV	R1,#00H
DLY1:	MOV	R0,#00H
	DJNZ	R0,$
	DJNZ	R1,DLY1
	RET
;
LONG_DELAY:
	MOV	R2,#02H	
DLY2:	MOV	R1,#00H
DLY3:	MOV	R0,#00H
	DJNZ	R0,$
	DJNZ	R1,DLY3
	DJNZ	R2,DLY2
	RET
;
;	LCD ǥ 
;
MSG1:	DB	'Temperat: ',00H	; 00H   ǹ
MSG2:	DB	2BH,00H			; (+)
MSG3:	DB	2DH,00H			; (-)
MSG4:	DB	0DFH,'C',00H		; ()
MSG5:	DB	'Humidity: ',00H
MSG6:	DB	25H,00H			; (%)
;
;	SO_RH ȯǥ
;
SO_RH_TBL:	;(00% ~ 99%)
	DW	0064H,007CH,0095H,00AEH,00C8H,00E1H,00FBH,0114H,012EH,0148H
	DW	0162H,017CH,0196H,01B0H,01CAH,01E5H,01FFH,021AH,0235H,0250H
	DW	026BH,0286H,02A1H,02BCH,02D7H,02F3H,030FH,032AH,0346H,0362H
	DW	037EH,039BH,03B7H,03D3H,03F0H,040DH,042AH,0447H,0464H,0481H
	DW	049FH,04BCH,04DAH,04F8H,0516H,0534H,0552H,0571H,0590H,05AEH
	DW	05CDH,05EDH,060CH,062BH,064BH,066BH,068BH,06ABH,06CCH,06ECH
	DW	070DH,072EH,074FH,0771H,0792H,07B4H,07D6H,07F9H,081BH,083EH
	DW	0861H,0884H,08A8H,08CBH,08EFH,0914H,0938H,095DH,0982H,09A7H
	DW	09CDH,09F3H,0A19H,0A40H,0A67H,0A8EH,0AB6H,0ADDH,0B06H,0B2EH
	DW	0B58H,0B81H,0BABH,0BD5H,0C00H,0C2BH,0C57H,0C83H,0CAFH,0CDCH
;
;	RH_linear ȯǥ
;
RH_LIN:
	DW	0005H,00F4H,01EDH,02E4H,03E4H,04DAH,05D9H,06CDH,07C9H,08C5H
	DW	09C0H,0ABAH,0BB3H,0CABH,0DA2H,0EA1H,0F97H,1094H,1191H,128CH
	DW	1387H,1480H,1579H,1670H,1766H,1865H,1962H,1A55H,1B51H,1C4BH
	DW	1D44H,1E45H,1F3BH,2031H,212EH,222AH,2325H,241FH,2518H,260FH
	DW	270EH,2803H,28FFH,29FAH,2AF4H,2BECH,2CE3H,2DE1H,2EDEH,2FD1H
	DW	30CBH,31CCH,32C4H,33BAH,34B6H,35B1H,36ABH,37A3H,38A2H,3997H
	DW	3A93H,3B8CH,3C85H,3D83H,3E79H,3F74H,406DH,416DH,4263H,435FH
	DW	4459H,4551H,464FH,4744H,483EH,493DH,4A34H,4B2FH,4C29H,4D20H
	DW	4E1DH,4F17H,500FH,510CH,5206H,52FFH,53FBH,54EFH,55EEH,56E4H
	DW	57E3H,58DBH,59D5H,5ACEH,5BC9H,5CC3H,5DBFH,5EB8H,5FAFH,60A9H
;
;	(0.01+0.00008*SO_RH)*250 ȯǥ
;
COEFF:
	DB	5,5,5,6,7,7,8,8,9,9
	DB	10,10,11,11,12,12,13,13,14,14
	DB	15,15,16,17,17,18,18,19,19,20
	DB	20,21,22,22,23,23,24,24,25,26
	DB	26,27,27,28,29,29,30,30,31,32
	DB	32,33,33,34,35,35,36,37,37,38
	DB	39,39,40,41,41,42,43,43,44,45
	DB	45,46,47,48,48,49,50,50,51,52
	DB	53,53,54,55,56,57,57,58,59,60
	DB	61,61,62,63,64,65,66,67,67,68
        END	; α׷ 
