;****************************************************
;         ļ ī(Frequency Counter)          *
;****************************************************
;
UNIT_4		BIT	P1.0		; 4511 Ĩ ο̺(1000 )
UNIT_3		BIT	P1.1		; 4511 Ĩ ο̺(100 )
UNIT_2		BIT	P1.2		; 4511 Ĩ ο̺(10 )
UNIT_1		BIT	P1.3		; 4511 Ĩ ο̺(1 )
;
HZ_LED		BIT	P1.4		; Hz  LED
KHZ_LED		BIT	P1.5		; KHz  LED
;
PT3		BIT	P1.6		; Ҽ(xx.xx) ǥ
PT2		BIT	P1.7		; Ҽ(xxx.x) ǥ
;
INDEX		EQU	08H		; ؽ
;
	ORG	0000H			; α׷ 
	JMP	START
;
	ORG	1BH			; Ÿ̸ 1 ͷƮ 
	JMP	TMR1_INT
;
START:
	MOV	SP,#50H			;  ̵
	MOV	INDEX,#0
	MOV	TMOD,#00010101B		; Ÿ̸1( 1), ī0( 1)
	CALL	TIME_CONST_SET		;  (0.001)
	SETB	ET1			; Ÿ̸ 1 ͷƮ ο̺
	SETB	ET0			; ī 0 ͷƮ ο̺
	JMP	$			; ͷƮ 
;
TMR1_INT:
	MOV	A,INDEX
	CJNE	A,#0,NEXT1
	JMP	INDEX0
NEXT1:	CJNE	A,#1,NEXT2
	JMP	INDEX1
NEXT2:	CJNE	A,#2,NEXT3
	JMP	INDEX2
NEXT3:	CJNE	A,#3,NEXT4
	JMP	INDEX3
NEXT4:	JMP	INDEX4
;
INDEX0:
	CLR	EA			; ͷƮ 𽺿̺
	CLR	TR0			; ī0 Stop
	CLR	TR1			; Ÿ̸1 Stop
;
	MOV	R1,TH0			; ļ < 10 ˻
	MOV	R0,TL0
	MOV	R3,#00H
	MOV	R2,#0AH
	CALL	COMPARE
	JNC	F100
	CLR	HZ_LED			; LED(Hz) on
	SETB	KHZ_LED			; LED(KHz) off
	MOV	INDEX,#1		; 0 ~ 9999Hz 
	MOV	TH1,#3CH		;  缳(=0.05sec)
	MOV	TL1,#0B0H		; 65536-50000=3CB0H
	MOV	TH0,#00H
	MOV	TL0,#00H
	MOV	R4,#20			; 0.05 x 20 = 1
	SETB	EA			; ü ͷƮ ο̺
	SETB	TR0			; ī0 RUN
	SETB	TR1			; Ÿ̸1 RUN
	RETI
;
F100:
	MOV	R1,TH0			; ļ < 100 ˻
	MOV	R0,TL0
	MOV	R3,#00H
	MOV	R2,#64H
	CALL	COMPARE
	JNC	F1000
	SETB	HZ_LED			; LED(Hz) off
	CLR	KHZ_LED			; LED(KHz) on
	MOV	INDEX,#2		; 10.00 ~ 99.99KHz 
	MOV	TH1,#3CH		;  缳(=0.05sec)
	MOV	TL1,#0B0H		; 65536-50000=3CB0H
	MOV	TH0,#00H
	MOV	TL0,#00H
	MOV	R4,#2			; 0.05 x 2 = 0.1
	SETB	EA			; ü ͷƮ ο̺
	SETB	TR0			; ī0 RUN
	SETB	TR1			; Ÿ̸1 RUN
	RETI
;
F1000:
	MOV	R1,TH0			; ļ < 1000 ˻
	MOV	R0,TL0
	MOV	R3,#03H
	MOV	R2,#0E8H
	CALL	COMPARE
	JNC	F10000
	SETB	HZ_LED			; LED(Hz) off
	CLR	KHZ_LED			; LED(KHz) on
	MOV	INDEX,#3		; 100.0 ~ 999.9KHz 
	MOV	TH1,#0D8H		;  缳(=0.01sec)
	MOV	TL1,#0F0H		; 65536-10000=D8F0H
	MOV	TH0,#00H
	MOV	TL0,#00H
	SETB	EA			; ü ͷƮ ο̺
	SETB	TR0			; ī0 RUN
	SETB	TR1			; Ÿ̸1 RUN
	RETI
;
F10000:					; ļ >= 1000 
	SETB	HZ_LED			; LED(Hz) off
	CLR	KHZ_LED			; LED(KHz) on
	MOV	INDEX,#4		; 1000 ~ 9999KHz 
	MOV	TH1,#0FCH		;  缳(=0.001sec)
	MOV	TL1,#18H		; 65536-1000=FC18H
	MOV	TH0,#00H
	MOV	TL0,#00H
	SETB	EA			; ü ͷƮ ο̺
	SETB	TR0			; ī0 RUN
	SETB	TR1			; Ÿ̸1 RUN
	RETI
;
INDEX1:
	DJNZ	R4,CONT1	
	CLR	EA			; ͷƮ 𽺿̺
	CLR	TR0			; ī0 Stop
	CLR	TR1			; Ÿ̸1 Stop
	CLR	PT3			; Dot(xx.xx) off
	CLR	PT2			; Dot(xxx.x) off
	CALL	DISP_FREQ		; ļ ÷
	CALL	TIME_CONST_SET		;  (0.001)
	MOV	INDEX,#0
	RETI
;
CONT1:	
	MOV	TH1,#3CH		;  缳(=0.05sec)
	MOV	TL1,#0B0H		; 65536-50000=3CB0H
	RETI
;
INDEX2:
	DJNZ	R4,CONT2	
	CLR	EA			; ͷƮ 𽺿̺
	CLR	TR0			; ī0 Stop
	CLR	TR1			; Ÿ̸1 Stop
	SETB	PT3			; Dot(xx.xx) on
	CLR	PT2			; Dot(xxx.x) off
	CALL	DISP_FREQ		; ļ ÷
	CALL	TIME_CONST_SET		;  (0.001)
	MOV	INDEX,#0
	RETI
;
CONT2:	
	MOV	TH1,#3CH		;  缳(=0.05sec)
	MOV	TL1,#0B0H		; 65536-50000=3CB0H
	RETI
;
INDEX3:
	CLR	EA			; ͷƮ 𽺿̺
	CLR	TR0			; ī0 Stop
	CLR	TR1			; Ÿ̸1 Stop
	CLR	PT3			; Dot(xx.xx) off
	SETB	PT2			; Dot(xxx.x) on
	CALL	DISP_FREQ		; ļ ÷
	CALL	TIME_CONST_SET		;  (0.001)
	MOV	INDEX,#0
	RETI
;
INDEX4:
	CLR	EA			; ͷƮ 𽺿̺
	CLR	TR0			; ī0 Stop
	CLR	TR1			; Ÿ̸1 Stop
	CLR	PT3			; Dot(xx.xx) off
	CLR	PT2			; Dot(xxx.x) off
	CALL	DISP_FREQ		; ļ ÷
	CALL	TIME_CONST_SET		;  (0.001)
	MOV	INDEX,#0
	RETI
;
TIME_CONST_SET:				;  Լ(0.001)
	MOV	TH1,#0FCH		; 65536-1000=FC18H
	MOV	TL1,#18H
	MOV	TH0,#00H		; ī0  = 0
	MOV	TL0,#00H
	SETB	EA			; ü ͷƮ ο̺
	SETB	TR0			; ī 0 RUN
	SETB	TR1			; Ÿ̸ 1 RUN
	RET
;
DISP_FREQ:
	MOV	R1,TL0
	MOV	R2,TH0
	CALL	WORD2BCD
;
	MOV	P2,R6			; 1000   ǥ
	CLR	UNIT_4			; 4511 ͸ ġ
	SETB	UNIT_4
;
	MOV	P2,R5			; 100   ǥ
	CLR	UNIT_3			; 4511 ͸ ġ
	SETB	UNIT_3
;
	MOV	P2,R4			; 10   ǥ
	CLR	UNIT_2			; 4511 ͸ ġ
	SETB	UNIT_2
;
	MOV	P2,R3			; 1   ǥ
	CLR	UNIT_1			; 4511 ͸ ġ
	SETB	UNIT_1
	RET
;
; 16-Bit  
; CY=1̸ X<Y, CY=0̸ X>Y
; X=R1 R0, Y=R3 R2
;
COMPARE:
	MOV	A,R0		; X Ʈ A 
	CLR	C		; CY=0
	SUBB	A,R2		; R0 - R2
	MOV	A,R1		; X Ʈ A 
	SUBB	A,R3		; R1 - R3
	RET
;
; 2 Ʈ 16 5 Ʈ BCD ȯ
; R2 R1 (16)---> R7 R6 R5 R4 R3 (BCD)
; R7~R0, A, B  
; () 91AFH = 37295d
;
WORD2BCD:
	MOV	R5,#00H
	MOV	R6,#00H
	MOV	R7,#00H
;
	MOV	A,R1
	MOV	B,#10
	DIV	AB
;
	MOV	R3,B		;  Ʈ R1  ڸ  ڸ 
	MOV	R4,A		; ̶ R1 9 ũ R4=1̰, ׷  0
;
	MOV	A,R2		; Ʈ R2 0̸
	JZ	SPRING		; ȯ 
	MOV	B,#10
	DIV	AB
;
	MOV	R5,B		; Ʈ ؼ   
	MOV	R6,A
;
	MOV	R0,#05 
	CALL	TRANSF
;
	INC	R0
	CALL	TRANSF
;
SPRING:	MOV	R0,#03
	CALL	DECADJ
	RET
;
TRANSF:	MOV	A,@R0
	MOV	B,#6
	MUL	AB
	DEC	R0
	DEC	R0
	ADD	A,@R0
	MOV	@R0,A
;
	INC	R0
	INC	R0
	MOV	A,@R0
	MOV	B,#5
	MUL	AB
	DEC	R0
	ADD	A,@R0
	MOV	@R0,A
;
	INC	R0
	MOV	A,@R0
	RL	A		; 2 Ѵ
	MOV	@R0,A
	RET
;
DECADJ:	MOV	A,@R0
DECLOP:	MOV	B,#10
	DIV	AB
	MOV	@R0,B
	INC	R0
	ADD	A,@R0
	MOV	@R0,A
	CJNE	R0,#7,DECLOP
	RET
	END			; α׷ 
