// LED ̿  ֻ

#include <reg51.h>
#include <stdlib.h>					// rand Լ ϱ 

sbit buzzer=P3^0;
sbit START=P2^0;
sbit STOP=P2^1;

code unsigned char lazer_sound[]={0x25,0x27,0x29,0x2c,0x2e,0x31,0x34,0x37,0x3b,
				0x3e,0x42,0x46,0x4a,0x4f,0x54,0x59,0x5e,0x64,
				0x6a,0x70,0x77,0x7e,0x85};

void delay(unsigned char i)
{
	while(i--);
}

void sound_gen(void)					// ȿ ߻ Լ
{
	unsigned char i, j, k, freq;
	for (i=0; i<7; i++) {
		for (j=0; j<=22; j++) {
			for (k=0; k<=0x0c; k++) {
				buzzer=0;		//  on
				freq=lazer[j];
				delay(freq);
				buzzer=1;		//  off
				freq=lazer_sound[j];
				delay(freq);
			}
		}
	}
}

void main(void)
{
	unsigned char i, j, dice;

	sound_gen();
	for (i=0; i<3; i++) {					// LED on/off (3ȸ)
		P1=0x00;					//  LED on
		for (j=0; j<250; j++) delay(0xa5);		// 0.25 
		P1=0x7f;					//  LED off
		for (j=0; j<250; j++) delay(0xa5);		// 0.25 
	}
	do {
		while(START==1);				// START ġ   
		do {
			if (j%5==0){				// ~~  ߻
				j=0;
				buzzer=0;			//  on
				for (j=0; j<50; j++) delay(0xff);
				buzzer=1;			//  off
			}
			dice=(rand()%6)+1;			// 1~6   
			if (dice==1) P1=0x77;
			else if (dice==2) P1=0x5d;
			else if (dice==3) P1=0x55;
			else if (dice==4) P1=0x2a;
			else if (dice==5) P1=0x22;
			else if (dice==6) P1=0x08;
			delay(0xff);
			j++;
		} while(STOP==1);				// STOP ġ   
		sound_gen();
	} while(1);
}
