//    ( IC 74194 )

#include <reg51.h>

sbit input_A=P1^0;
sbit input_B=P1^1;
sbit S0=P1^2;
sbit S1=P1^3;
sbit CLK=P1^4;

void delay(unsigned int i)
{
	while(i--);
}

void TMR0_int(void) interrupt 1	// Ÿ̸/ī 0 ͷƮ ͹ȣ = 1
{
	TR0=0;			// Ÿ̸ 0 Stop
	CLK=~CLK;		// Ŭ 
	TH0=0xfc;		//  Ư °  缳
	TL0=0xbf;		// 600PPS(Pulse Per Second)=fcbf
	TR0=1;			// Ÿ̸ 0 Run
	return;
}

void main(void)
{
	unsigned char i;

	TMOD=0x11;		// Ÿ̸ 0,  1
	TH0=0xfc;		//  Ư °  
	TL0=0xbf;		// 600PPS(Pulse Per Second) = fcbf
	ET0=1;			// Ÿ̸ 0 ͷƮ ο̺
	PT0=1;			// Ÿ̸ 0 ͷƮ 켱 High
	EA=1;			// ü ͷƮ ο̺
	TR0=1;			// Ÿ̸ 0 Run

	input_A=1;		// 1 ڹ
	input_B=0;

	S0=1; S1=1;		//  ʱȭ
	delay(1000);		// ణ

	do {
		S0=1; S1=0;	// ð  5 ȸ
		for (i=0; i<10; i++) delay(0xb100);

		S0=0; S1=1;	// ݽð  5 ȸ
		for (i=0; i<10; i++) delay(0xb100);
	} while(1);
}
