// ͷƮ ̿  ð

#include <reg51.h>

sbit scnd_sw=P3^0;
sbit mint_sw=P3^1;
sbit hour_sw=P3^2;
sbit ampm_sw=P3^3;
sbit day_sw=P3^4;
sbit am_led=P3^5;
sbit pm_led=P3^6;

unsigned char scancntr, onecnt, hour, minute, second, ampm, day;
unsigned char sec01, sec10, min01, min10, hur01, hur10;

void delay(unsigned int i)
{
    while(i--);
}

void clock(void)		// ð 
{
	second++;					// ʸ +1
	if (second==60) {				// 60ʰ Ǿ°?
		second=0;				// 60ʸ ʴ 0 
		minute++;				//  +1
			if (minute==60) {		// 60 Ǿ°?
				minute=0;		// 60 Ǿ  0 
				hour++;			// ø +1
				if (hour==12) {		// 12ð Ǿ°?
					am_led=~am_led;	// 12ð Ǿ ,  
					pm_led=~pm_led;
					if (ampm==0) ampm=1;
					else {		// ̸  
						ampm=0;
						day=day >> 1 | 0x80;
						if (day==0xff) day=0xbf;
						P2=day;
					}
				}
				if (hour==13) hour=1;	// 13ð Ǿ ø 1÷ 
			}
	}
}

void scan(void)
{
	unsigned char temp, index;

	scancntr++;
	if (scancntr==6) scancntr=0;

	switch(scancntr) {			// 7-׸Ʈ , , ø ÷ϴ Լ
		case 0: temp=sec01; break;
		case 1: temp=sec10; break;
		case 2: temp=min01; break;
		case 3: temp=min10; break;
		case 4: temp=hur01; break;
		case 5: temp=hur10; break;
	}
	index=scancntr<<4;
	P1=temp | index;
}

void convert(void)
{
	sec10=second/10;		// , 10 ڸ
	sec01=second%10;		// , 1 ڸ
	min10=minute/10;		// , 10 ڸ
	min01=minute%10;		// , 1 ڸ
	hur10=hour/10;			// , 10 ڸ
	hur01=hour%10;			// , 1 ڸ
}

void TMR0_int(void) interrupt 1		// Ÿ̸/ī 0 ͷƮ  ȣ = 1
{
	TH0=0xf0;			// (65536-4000)=F060H
	TL0=0x60;			// ͷƮ ð : 4000us=4ms

	onecnt--;
	if (onecnt==0) {		// ͷƮ 250 ߻ߴ°?
		onecnt=250;		// ߻Ǿ 1ʰ  ̹Ƿ
		clock();		// , , ʸ ٽ 
	}
	scan();				// 7-׸Ʈ , ,  ÷
	return;
}

void main(void)
{
	scancntr=0;			// scan Լ  ī
	onecnt=250;			// 250x4000us = 1sec
	day=0xbf;			//   
	P2=day;				// Ͽ LED on
	ampm=0;				// 
	am_led=0;			// AM LED on
	pm_led=1;			// PM LED off
	hour=12;			// 12
	minute=0;			// 00
	second=0;			// 00

	TMOD=0x01;			// Ÿ̸ 0,  1
	TH0=0xf0;			// (65536-4000)=F060H
	TL0=0x60;			// ͷƮ ð  : 4000us=4ms
	IE=0x82;			// ͷƮ ο̺
	TR0=1;				// Ÿ̸ 0 Run

	do {
		convert();
		if (scnd_sw==0) {	//   Ű ԷµǾ ˻
			second=0;	// Ű ԷµǾ ʴ 00 
			delay(0x0700);	// ٿ Ͽ 
			while(!scnd_sw);// ġ   while ȿ 
			delay(0x0700);	// ٿ Ͽ 
		}
		else if (mint_sw==0) {	//   Ű ԷµǾ ˻
			minute++;	// ԷµǾ  +1
			if (minute==60) minute=0;
			delay(0x0700);	// ٿ Ͽ 
			while(!mint_sw);// ġ   while ȿ 
			delay(0x0700);	// ٿ Ͽ 
		}
		else if (hour_sw==0) {	//   Ű ԷµǾ ˻
			hour++;		// ԷµǾ ø +1
			if (hour==13) hour=1;
			delay(0x0700);	// ٿ Ͽ 
			while(!hour_sw);// ġ   while ȿ 
			delay(0x0700);	// ٿ Ͽ 
		}
		else if (ampm_sw==0) {	// /  Ű ԷµǾ ˻
			if (ampm==0) {	//  ̸ ķ 
				ampm=1;
				am_led=1;	// PM ÷
				pm_led=0;
			}
			else {			//  ĸ  
				ampm=0;
				am_led=0;	// AM ÷
				pm_led=1;
			}
			delay(0x0700);		// ٿ Ͽ 
			while(!ampm_sw);	// ġ   while ȿ 
			delay(0x0700);		// ٿ Ͽ 
		}
		else if (day_sw==0) {		//   Ű ԷµǾ ˻
			day=day>>1 | 0x80;	// ԷµǾ  
			if (day==0xff) day=0xbf;
			P2=day;
			delay(0x0700);		// ٿ Ͽ 
			while(!day_sw);		// ġ   while ȿ 
			delay(0x0700);		// ٿ Ͽ 
		}
	} while(1);
}
